// YUSB.h: CYUSB NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_YUSB_H__94162D42_CC8C_4C9A_9877_DC9EEC88462C__INCLUDED_)
#define AFX_YUSB_H__94162D42_CC8C_4C9A_9877_DC9EEC88462C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define USBOPEN_SUCCESS         0   /* no error */
#define USBOPEN_ERR_ACCESS      1   /* not enough permissions to open device */
#define USBOPEN_ERR_IO          2   /* I/O error */
#define USBOPEN_ERR_NOTFOUND    3   /* device not found */
#define USBOPEN_ERR_DLL_NOTFOUND    4


#define DEBUG_PRINT(arg)


class CYUSB  
{
public:
	int OpenDevice();
private:
	// Rg[] (SetFeature / GetFeature ̃bp)
	int HidGetReport(HANDLE device, int reportNumber, char* buffer, int* len);
	int HidSetReport(HANDLE device, char* buffer, int len);
	// C^vg] (CreateFile / WriteFile / ReadFile ̃bp)
	 // stub.

	// foCXƂ
	void HidCloseDevice(HANDLE device);
	// foCXJ
	int HidOpenDevice(HANDLE* device, int vendorID, int productID, int usesReportIDs, char* vendorName, char* productName);
public:
	BOOL DeviceIsOpen();
	int GetReport(char* buffer, int len);
	int SendReport(char* buffer, int len);
	int CloseDevice();
	void SendTest2(int state);
	void Test();
	CYUSB();
	virtual ~CYUSB();

private:
	void convertUniToAscii(char* buffer);
	
	// ֐|C^Astruct ̒`
	typedef struct _HIDD_ATTRIBUTES {
		ULONG   Size;            // = sizeof (struct _HIDD_ATTRIBUTES)
		USHORT  VendorID;
		USHORT  ProductID;
		USHORT  VersionNumber;
	} HIDD_ATTRIBUTES, *PHIDD_ATTRIBUTES;

	typedef BOOL __stdcall HIDD_GETHIDGUID(GUID *pGuid);
	HIDD_GETHIDGUID *HidD_GetHidGuid;

	typedef BOOL __stdcall HIDD_GETATTRIBUTES(HANDLE HidDeviceObject, PHIDD_ATTRIBUTES Attributes);
	HIDD_GETATTRIBUTES *HidD_GetAttributes;
	
	typedef BOOL __stdcall HIDD_GETFEATURE(HANDLE HidDeviceObject, PVOID ReportBuffer, ULONG ReportBufferLength);
	HIDD_GETFEATURE *HidD_GetFeature;
	
	typedef BOOL __stdcall HIDD_SETFEATURE(HANDLE HidDeviceObject, PVOID ReportBuffer, ULONG ReportBufferLength);
	HIDD_SETFEATURE *HidD_SetFeature;

	typedef BOOL __stdcall HIDD_GETMANUFACTURERSTRING(HANDLE HidDeviceObject, PVOID Buffer, ULONG BufferLength);
	HIDD_GETMANUFACTURERSTRING* HidD_GetManufacturerString;
	
	typedef BOOL __stdcall HIDD_GETPRODUCTSTRING(HANDLE HidDeviceObject, PVOID Buffer, ULONG BufferLength);
	HIDD_GETPRODUCTSTRING* HidD_GetProductString;


	HMODULE hModule;
	HANDLE  m_device;
};

#endif // !defined(AFX_YUSB_H__94162D42_CC8C_4C9A_9877_DC9EEC88462C__INCLUDED_)
