// INIHandler.cpp
// (c)2011 Eleken

#include "stdafx.h"
#include "INIHandler.h"

CINIHandler::CINIHandler(){
	GetModuleFileName((HINSTANCE)GetModuleHandle(NULL), MyPath, 512);
	MyPath[strlen(MyPath)-3] = 'i';
	MyPath[strlen(MyPath)-2] = 'n';
	MyPath[strlen(MyPath)-1] = 'i';
}
void CINIHandler::Write(const char* section, const char* key, const char* word){
	WritePrivateProfileString(section, key, word, MyPath);
}
void CINIHandler::Read(const char* section, const char* key, char* word, DWORD size){
	GetPrivateProfileString(section, key, "", word, size, MyPath);
}
void CINIHandler::WriteInt(const char* section, const char* key, const int d){
	char word[128];
	sprintf(word, "%d", d);
	WritePrivateProfileString(section, key, word, MyPath);
}
int CINIHandler::ReadInt(const char* section, const char* key){
	char buf[128];
	Read(section, key, buf, 128);
	return (atoi(buf));
}
void CINIHandler::WriteFloat(const char* section, const char* key, const float d){
	char word[128];
	sprintf(word, "%f", d);
	WritePrivateProfileString(section, key, word, MyPath);
}
float CINIHandler::ReadFloat(const char* section, const char* key){
	char buf[128];
	Read(section, key, buf, 128);
	return (atof(buf));
}
