// YTaskBarLaunchDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "YTaskBarLaunch.h"
#include "YTaskBarLaunchDlg.h"

#include "INIHandler.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// MessageBox ̌`Debug
void DebugMsg(char* text, ...){
	va_list ap;
	char buf[512];
	va_start(ap, text);
	vsprintf(buf, text, ap);
	MessageBox(NULL, buf, "fobO", MB_OK|MB_ICONASTERISK);
	
	va_end(ap);
}


#define TB_CALLBKMSG 128

/////////////////////////////////////////////////////////////////////////////
// CYTaskBarLaunchDlg _CAO

CYTaskBarLaunchDlg::CYTaskBarLaunchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CYTaskBarLaunchDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CYTaskBarLaunchDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CYTaskBarLaunchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CYTaskBarLaunchDlg)
	DDX_Control(pDX, IDC_SLIDER3, m_slider3);
	DDX_Control(pDX, IDC_SLIDER2, m_slider2);
	DDX_Control(pDX, IDC_SLIDER1, m_slider1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CYTaskBarLaunchDlg, CDialog)
	//{{AFX_MSG_MAP(CYTaskBarLaunchDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_MENUITEM_END, OnMenuitemEnd)
	ON_COMMAND(ID_MENUITEM_SETTING, OnMenuitemSetting)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CYTaskBarLaunchDlg bZ[W nh

BOOL CYTaskBarLaunchDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	CINIHandler ini;
	int timerInterval = ini.ReadInt("Global", "Interval");
	if(timerInterval < 100) timerInterval = 200;

	int brightness1 = ini.ReadInt("Global", "Brightness1");
	if(brightness1 < 2) brightness1 = 250;
	
	int brightness2 = ini.ReadInt("Global", "Brightness2");
	if(brightness2 < 2) brightness2 = 250;
	
	int brightness3 = ini.ReadInt("Global", "Brightness3");
	if(brightness3 < 2) brightness3 = 250;

	m_deviceIsChecked = 0;
	m_timer = SetTimer(12, timerInterval, 0); // timer : 200ms

	m_slider1.SetRange(0, 254);
	m_slider1.SetPos(brightness1);

	m_slider2.SetRange(0, 254);
	m_slider2.SetPos(brightness2);

	m_slider3.SetRange(0, 254);
	m_slider3.SetPos(brightness3);


	return FALSE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}


// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CYTaskBarLaunchDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CYTaskBarLaunchDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



void CYTaskBarLaunchDlg::OnCancel() 
{
	ShowNotifyIcon();
	ShowWindow(SW_HIDE);
	return;
	
	CDialog::OnCancel();
}

void CYTaskBarLaunchDlg::PostNcDestroy() 
{
	CDialog::PostNcDestroy();
}

LRESULT CYTaskBarLaunchDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if(message == TB_CALLBKMSG){ // R[obNbZ[W
		if(lParam == WM_RBUTTONUP){
			// |bvAbvj[̕\
			CMenu menu;
			POINT pos;
			::GetCursorPos(&pos);
			menu.LoadMenu(IDR_MENU1);
			this->SetForegroundWindow();
			menu.GetSubMenu(0)->TrackPopupMenu(TPM_RIGHTBUTTON | TPM_RIGHTALIGN | TPM_BOTTOMALIGN , pos.x, pos.y, this);

			menu.DestroyMenu();
		}
	}
	
	return CDialog::DefWindowProc(message, wParam, lParam);
}

void CYTaskBarLaunchDlg::OnMenuitemEnd() 
{
	CINIHandler ini;
	ini.WriteInt("Global", "Brightness1", m_slider1.GetPos());
	ini.WriteInt("Global", "Brightness2", m_slider2.GetPos());
	ini.WriteInt("Global", "Brightness3", m_slider3.GetPos());

	DeleteNotifyIcon();
	CDialog::OnCancel();
}

void CYTaskBarLaunchDlg::OnMenuitemSetting() 
{

	DeleteNotifyIcon();
	ShowWindow(SW_SHOW);
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// USB foCXƂ
	m_Usb.CloseDevice();
}

void CYTaskBarLaunchDlg::ShowNotifyIcon()
{
	NOTIFYICONDATA notif;

	notif.cbSize = sizeof(NOTIFYICONDATA);
	notif.hWnd = this->m_hWnd;
	notif.uID = 0;
	notif.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	notif.uCallbackMessage = TB_CALLBKMSG;
	notif.hIcon = m_hIcon;
	strcpy(notif.szTip, "YTaskBarLaunch");

	int i;
	for(i=0; i<10; i++){
		BOOL ret = Shell_NotifyIcon(NIM_ADD, &notif);
		if(ret == TRUE) break;
		_sleep(1000);
	}


}

void CYTaskBarLaunchDlg::DeleteNotifyIcon()
{
	NOTIFYICONDATA notif;

	notif.cbSize = sizeof(NOTIFYICONDATA);
	notif.hWnd = this->m_hWnd;
	notif.uID = 0;
	notif.uFlags = 0;
	notif.hIcon = m_hIcon;

	Shell_NotifyIcon(NIM_DELETE, &notif);
}

void CYTaskBarLaunchDlg::OnButton1() 
{
//	CYUSB u;
	SendTest2(255);
	
}

void CYTaskBarLaunchDlg::OnButton2() 
{
//	CYUSB u;
	SendTest2(0);
}

void CYTaskBarLaunchDlg::OnButton4() 
{
//	CYUSB u;
	SendTest2(255);
}

void CYTaskBarLaunchDlg::OnButton3() 
{
	OnMenuitemEnd();
}

void CYTaskBarLaunchDlg::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent == 12){
		if(m_deviceIsChecked == 0){
			//  USB foCXJAACRŎs
			m_deviceIsChecked = 1;
			OnOK();
		}else{
			SendCurrentState();
		}
	}
	
	CDialog::OnTimer(nIDEvent);
}


void CYTaskBarLaunchDlg::OnOK() 
{

	int ret;
	if(ret = m_Usb.OpenDevice(USB_CFG_VENDOR_ID, USB_CFG_DEVICE_ID)){
		DebugMsg("Error: USB device cannot open!(%d)", ret);
		return;
	}

	ShowNotifyIcon();
	ShowWindow(SW_HIDE);
/*
	// Display Test
	char buffer[8+1];
	buffer[0] = 0;
	buffer[1] = 1;
	for(int i=0; i<8; i++){
		m_Usb.SendReport(buffer, sizeof(buffer));
		Sleep(50);
		buffer[1] <<= 1;
	}

	SendCurrentState(1);
*/
	return;

//	CDialog::OnOK();
}

void CYTaskBarLaunchDlg::SendCurrentState(int sendByForce)
{
	static int LedState_old;

	if(m_Usb.DeviceIsOpen() == TRUE){
		// IME ԂUSBfoCXɑM
	//			HIMC imm;
		HWND fwd = ::GetForegroundWindow(), imwd;
		imwd = ImmGetDefaultIMEWnd(fwd);
		if(imwd){
			// ost : IME  ON/OFF (0/1)
			// insstate : Insert  ON/OFF (0/1)
			int ost = ::SendMessage(imwd, WM_IME_CONTROL, 5, NULL); // IMC_GETOPENSTATUS
			if(ost != 0) ost = 1;
			int insstate = (GetKeyState(VK_INSERT) == 0x0001)? 1: 0;
			
			
			char buffer[1+USB_REPORT_SIZE];
			buffer[0] = 0;
			int LedState = ost | (insstate << 1);
			const int trialTimes = 3; // s
			int i;
			if(sendByForce || (LedState_old != LedState)){ // LED Ԃɕω
				buffer[1] = LedState;
				buffer[2] = m_slider3.GetPos();
				buffer[3] = m_slider2.GetPos();
				buffer[4] = m_slider1.GetPos();
				// USBfoCX֑M
				for(i=0; i<3; i++){
					if(m_Usb.SendOutput(buffer, sizeof(buffer)) == 0){
						break;
					}
				}
				if(i == 3){
					OnMenuitemSetting();
				}

				LedState_old = LedState;
			}else{
				/*
				// USBfoCXM
				for(i=0; i<3; i++){
					if(m_Usb.GetReport(buffer, 0, sizeof(buffer)) == 0){
						break;
					}
				}
				if(i == 3){
					OnMenuitemSetting();
				}
				if(ost != (buffer[1] & 1)){
					if(buffer[1] & 1) ost = 1;
					else ost = 0;
					::SendMessage(imwd, WM_IME_CONTROL, 6, ost); // IMC_SETOPENSTATUS
				}
				*/

			}

		}
	}
}

void CYTaskBarLaunchDlg::SendTest2(int a)
{
	// foCXJ
	int ret;
	if(ret = m_Usb.OpenDevice(USB_CFG_VENDOR_ID, USB_CFG_DEVICE_ID)){
		DebugMsg("Error: USB device not found!(%d)", ret);
		return;
	}

	// f[^𑗂
	char buffer[1+USB_REPORT_SIZE];
	buffer[0] = 0;
	buffer[1] = (char)a;
	buffer[2] = m_slider3.GetPos();
	buffer[3] = m_slider2.GetPos();
	buffer[4] = m_slider1.GetPos();
	if(ret = m_Usb.SendOutput(buffer, sizeof(buffer))){
		DebugMsg("Error: SendOutput(%d)", ret);
		return;
	}

	m_Usb.CloseDevice();

}

void CYTaskBarLaunchDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SendTest2(255);
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
